{% set scss.background_image %}
{# Common to all background images #}
section.slide {
    background: {{ content["background-fill"] }};
    &:before {
        content: "";
        position: absolute;
        width: 100%;
        height: 100%;
        top: 0;
        left: 0;
        z-index: 1;
        filter: blur({{ content.blur }}px);
    }
}
section.slide > * {
    z-index: 100;
}
{% if content.image %}
{# If image is set, use that as the background #}
section.slide {
    &:before {
        background: no-repeat url('{{ url_for("images.show_image", filename=content.image, origin=content.origin) }}') center center;
        background-size: {{ content["background-size"] }};
        transform: scale({{ 1 + content.blur/400 }});
    }
}
{% else %}
{# Otherwise use a pattern with a bit of gradient over the top #}
section.slide {
    &:before {
        background: no-repeat url('{{ url_for("images.generate_pattern", idx=content.pattern, colourstr=content.colours) }}') center center / cover;
        transform: scale({{ 1 + content.blur/400 }});
    }
    &:after {
        content: "";
        background: linear-gradient(60deg, white, black);
        opacity: 0.3;
        position: absolute;
        width: 100%;
        height: 100%;
        top: 0;
        left: 0;
        z-index: 2;
    }
}
{% endif %}
{% endset %}

{# Text template is maximum three styled boxes over a generated image #}
{% set scss.top_text %}
section.slide article {
    overflow: visible;
    padding-left: 4vw;
    padding-right: 4vw;
}

.box {
    color: {{ content["text-colour"] }};
    background: {{ content["box-colour"] }};
    box-shadow: 0 0 0.5rem {{ content["box-shadow"] }}, 0.2rem 0.2rem 1.0rem {{ content["box-shadow"] }};
    padding: 1.0vh 0.1vw;
    h1, h2, p {
        color: {{ content["text-colour"] }};
        text-shadow: 0 0 0.1em {{ content["text-shadow"] }}, 0.05em 0.05em 0.2em {{ content["text-shadow"] }};
    }
    h1 {
        font-size: 9vh;
        margin: 1vh 2vw;
    }
    h2 {
        font-size: 6vh;
        margin: 0 2vw;
    }
    :empty {
        padding: 0;
    }
}

.container {
    margin: 0 auto;
}

.box-position {
    {% if content["box-position"] == "left" %}
    margin-right: 50%;
    {% elif content["box-position"] == "right" %}
    margin-left: 50%
    {% endif %}
}

.qr-code {
    position: absolute;
    right: 0;
    bottom: 0;
    filter: drop-shadow(0 0 0.05rem white) drop-shadow(0rem 0rem 0.1rem white);
    overflow: visible !important;
    padding: 0.5vh 1vw;
    img {
        height: 16vh;
    }
}


{% endset %}
<article class="flex-column add-footer box-position">
    <div class="container" id="content-header">
        {% if content.header %}
            <div class="box">
                <h1>{{ content.header }}</h1>
            </div>
        {% endif %}
    </div>
    <div class="container" id="content-main">
        {% if content.main %}
            <div class="box">
                {% for textstr in content.main.splitlines() %}
                <h2>{{ textstr or "&nbsp;"|safe }}</h2>
                {% endfor %}
            </div>
        {% endif %}
    </div>
    <div class="container" id="content-secondary">
        {% if content.secondary %}
            <div class="box">
                {% for textstr in content.secondary.splitlines() %}
                <h2>{{ textstr or "&nbsp;"|safe }}</h2>
                {% endfor %}
            </div>
        {% endif %}
    </div>
</article>

{% if content.url %}
    <a href="{{ content.url }}" class="qr-code" target="_blank">
        <img src="/image/qr?url={{ content.url }}" alt="">
    </a>
{% endif %}

<script>
  var resizeIfOverlap = function() {
    var fontSize = 6; // vh
    // Set minimum spacing based on 2% of the window height so it
    // looks the same with resizing
    var spacing = window.innerHeight * 0.02;
    // Relative to the bottom of the article as the page falls off the
    // bottom on mobile
    var articleContainer = document.getElementsByTagName("article")[0];
    var contentMain = document.getElementById("content-main");
    var contentSecondary = document.getElementById("content-secondary");
    var textNodes = document.querySelectorAll(".container h2");
    // Check if the middle boxes are too close, or fall of the end
    // of the page
    var overlap = function () {
      var articleBox = articleContainer.getBoundingClientRect();
      var mainBox = contentMain.getBoundingClientRect();
      var secondaryBox = contentSecondary.getBoundingClientRect();
      return ((articleBox.bottom - secondaryBox.bottom < spacing)
        || (secondaryBox.top - mainBox.bottom < spacing ));
    };
    // Scale boxes down until they fit, anything over 30 lines
    // looks stupid anyway so stop then
    for (var scaleFactor = 7; scaleFactor < 30; scaleFactor++) {
        for (var i = 0; i < textNodes.length; i++) {
          textNodes[i].style.fontSize = (7 * fontSize / scaleFactor) + "vh";
        }
        // Always rescale at least once to allow scaling up and down
        if (!overlap()) break;
      }
    };
  // Resize on relevant events
  window.addEventListener('load', resizeIfOverlap);
  window.addEventListener('resize', resizeIfOverlap);
</script>